% function [js,fs,jstd,fstd,counts]=computeTreeScoreByLevels(threshold,all,bfs)
% display a histogram of all j or f scores by thier levles
% threshold - if all flag is down (== only enriched branches are calculated)
%     then it selects only branches above the threshold
%  all = a 0/1 flag - if all =1 calculation is done according to all
%  branches if all =0 calculation is done according to enriched branches
%  only
%  bfs - a 0/1 flag. if bfs =1 levels are determined by their bfs order
%  (from top) if bfs =0 levels are detemined vy thier regular tree levels
%  (similar ot thier distance from leaves)
%     noLeaves - exclude Leaves from j/f calculation
function [js,fs,jstd,fstd,counts,enrichCount]=computeTreeScoreByLevels(threshold,all,bfs,noLeaves)
global hash;
len = size(hash,1);
[inds2] =find (hash(:,6) <threshold) ; % only the colored
[vals,inds]=sort(unique(hash(:,7)));%compute the levels
[bfsMat]=bfsTree();
if noLeaves %only branches
    numElems = (hash(1,1)+1)/2;
    validItems = find(hash(:,1)>numElems);
else
    validItems = 1:size(hash,1);
end

for ind =2:length(vals)%start from the second (first is root)
    if bfs
        [inds1] = bfsMat(ind,:);
        inds1=inds1(find(inds1));%without the 0;
    else
        [inds1] =find (hash(:,7) ==vals(ind));
    end
    inds1=intersect(inds1,validItems); %result  of noLeaves option
    if isempty(inds1)
        js1(ind) =0;
        fs1(ind) =0;
        jstd1(ind) = 0;
        fstd1(ind) = 0;
    else
        js1(ind) = mean(hash(inds1,8));
        jstd1(ind) = std(hash(inds1,8));
        fs1(ind) = mean(hash(inds1,9));
        fstd1(ind) = std(hash(inds1,9));
        inds = intersect (inds1,inds2);
    end
    counts(ind)= length(inds1);
    if  counts(ind) >0
        enrichCount(ind)=length(inds)/ counts(ind);
    else 
        enrichCount(ind)=0;
    end
    inds=intersect(inds,validItems); %result  of noLeaves option
    
    if isempty(inds)
        js2(ind) =0;
        fs2(ind) =0;
        jstd2(ind) = 0;
        fstd2(ind) = 0;
    else
        levelSize = length(inds1);% the average computation is based on all nodes and not only the colored 
        %(since the non colored are considered as 0)
        if levelSize>0
            js2(ind) = sum(hash(inds,8))/levelSize;
            fs2(ind) = sum(hash(inds,9))/levelSize;
        else
            js2(ind) =0;
            fs2(ind) =0;
        end
        jstd2(ind) = std(hash(inds,8));% here i was lazy to fix... (need to adjust to levelSize...)
        fstd2(ind) = std(hash(inds,9));% here i was lazy to fix... (need to adjust to levelSize...)
        
%    Old     js2(ind) = mean(hash(inds,8));
%         fs2(ind) = mean(hash(inds,9));
%         jstd2(ind) = std(hash(inds,8));
%         fstd2(ind) = std(hash(inds,9));
    end
end
if all
    js=js1;
    fs=fs1;
    jstd =jstd1;
    fstd=fstd1;
else
    js=js2;
    fs=fs2;
    jstd =jstd2;
    fstd=fstd2;
end
counts(1)=1;