% out of N elenments in the db, there are K elements with the feature
% my algorithm found k out of n.
% what is the p-value?
%
%   useFDR -    1 - yes (default)
%               0 - now    
% majority - (0-100) a node is enrich only if majority% of its elements are in the
% same color...
function [enrichmentMatrix] = enrichmentCalculation(partitionMatrix, realMatrix, useFDR,majority)
[len,x] = size(realMatrix);
if x ==1
    numOfClust = max(realMatrix);
    tempMat =zeros (len,numOfClust);
    for ind =1:numOfClust
        tempMat(find(realMatrix==ind),ind) =1;
    end
    realMatrix=tempMat;
else
    numOfClust=x;
end
N = len;
[partitions,len] = size (partitionMatrix);
enrichmentMatrix = ones(partitions,numOfClust);
for ind =1:partitions
    calc = partitionMatrix(ind,:);
    n = sum(calc);
%     if n < 3 %test: too small branches are trivial
%         continue;
%     end
    for jnd =1:numOfClust
        real = realMatrix(:,jnd);
        K = sum(real);
        k = sum(real&calc');
        pVal = calculatePValue(k,n,K,N);
        if (pVal < eps)&&(n <5 ) % too small branches are trivial
            pVal = 1e-5;
        end
        if majority>0
            if k<n*majority
                pVal=1;
            end
        end
        enrichmentMatrix(ind,jnd) = pVal;
    end
end




function [pVal] = calculatePValue(k,n,K,N)
if k<1
    k=1;
end
pVal = 1-(hygecdf(k-1,N,K,n));%from the help + menachem
% alon... pVal = 1-(hygecdf(k-1,N,n,K));
