%function []= paintTree(parents, indices,realMapping)
% Input: 
% parents - tree representation in a paarent format (more help see treeplot)
% indices = the indices of the tree
% realMapping - real classification
%%   paintLevel - 0 - black, 1 - leaves, 2 - leaves + enriched branches
%   useFDR -    1 - yes (default)
%               0 - no    
% h - hanfle to figure
% threshold for significance
% majority - (0-100) a node is enrich only if majority% of its elements are in the
% same color...
function [parents,cscore,fscoreOfTree,averageJaccard]= paintTree(treeAsChild,realMapping,paintLevel,paintFactor,useFDR,threshold,majority,h)
% parents - tree representation in a paarent format (more help see treeplot)
% indices = the indices of the tree
[parents,indices] = children2ParentTree(treeAsChild);
hnl=0;
cscore=0; %Init
fscoreOfTree=0;%Init
averageJaccard=0;%Init
if nargin == 7 % pointer to handle
    mytreeplot(parents,'.k','-k',h);
else
   treeplot(parents,'.k','-k');
end
hold on

dcm_obj = datacursormode;
set(dcm_obj,'UpdateFcn',@myupdatefcn)
datacursormode on
% Click on line to select
[x1,y1,h]=treelayout(parents);
% the hash
global hash;
hash = indices';
hash(:,2) = parents';
hash(:,3) = x1';
hash(:,4) = y1';
hash(:,5) = ones(size(x1'));%before FDR
hash(:,6) = ones(size(x1'));%after FDR
[vals,inds]=sort(unique(y1),'descend');%compute the levels
for ind =1:length(vals)
    [inds] = find (vals(ind) ==y1);
    hash(inds,7) = ind;  
end
nElems = length(realMapping);
if paintLevel & nElems% paint leaves
    for ind = 1:length(realMapping)
        clust =realMapping(ind);
        pos = find (indices==ind);
       marker=  getColorOfCluster(clust);
       plot(x1(pos), y1(pos), '.','Color',marker);  
    end
    if paintLevel>1 % and also branches   
        [partition]=buildPartitionFromChildrenTree(treeAsChild);
        if size(realMapping,1)~=nElems
            realMapping=realMapping';%transpose
        end
        [enrichmentMatrix] = enrichmentCalculation(partition, realMapping,useFDR,majority);
        cscore =paintEnrichedVertices(parents,enrichmentMatrix,indices,paintFactor,useFDR,threshold) ;
    end
end
if isempty(realMapping)==0
    [fscoreOfTree,averageJaccard]=computeTreeScore(realMapping);
end
%[j1,f1,j2,f2]=computeTreeScoreByLevels(threshold);
hold off
axis off