function varargout = scoresDistribution(varargin)
% SCORESDISTRIBUTION M-file for scoresDistribution.fig
%      SCORESDISTRIBUTION, by itself, creates a new SCORESDISTRIBUTION or raises the existing
%      singleton*.
%
%      H = SCORESDISTRIBUTION returns the handle to a new SCORESDISTRIBUTION or the handle to
%      the existing singleton*.
%
%      SCORESDISTRIBUTION('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in SCORESDISTRIBUTION.M with the given input arguments.
%
%      SCORESDISTRIBUTION('Property','Value',...) creates a new SCORESDISTRIBUTION or raises the

%      existing singleton*.  Starting from the left, property value pairs are

%      applied to the GUI before scoresDistribution_OpeningFunction gets called.  An

%      unrecognized property name or invalid value makes property application

%      stop.  All inputs are passed to scoresDistribution_OpeningFcn via varargin.

%

%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one

%      instance to run (singleton)".

%

% See also: GUIDE, GUIDATA, GUIHANDLES



% Edit the above text to modify the response to help scoresDistribution



% Last Modified by GUIDE v2.5 09-Nov-2006 11:47:04



% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @scoresDistribution_OpeningFcn, ...
    'gui_OutputFcn',  @scoresDistribution_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end



if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end

% End initialization code - DO NOT EDIT



% --- Executes just before scoresDistribution is made visible.

function scoresDistribution_OpeningFcn(hObject, eventdata, handles, varargin)

% This function has no output args, see OutputFcn.

% hObject    handle to figure

% eventdata  reserved - to be defined in a future version of MATLAB

% handles    structure with handles and user data (see GUIDATA)

% varargin   command line arguments to scoresDistribution (see VARARGIN)



% Choose default command line output for scoresDistribution

handles.output = hObject;
handles.jaccards = 0;
handles.fScores = 0;
handles.cScores = 0;
handles.jaccardsSTD =0;
handles.fScoresSTD =0;
if(nargin > 3)
    for index = 1:2:(nargin-3),
        if nargin-3==index break, end
        switch lower(varargin{index})
            case 'threshold'
                handles.threshold= varargin{index+1};
        end
    end
end
% Update handles structure
guidata(hObject, handles);



% This sets up the initial plot - only do when we are invisible

% so window can get raised using scoresDistribution.





% UIWAIT makes scoresDistribution wait for user response (see UIRESUME)

uiwait(handles.figure1);





% --- Outputs from this function are returned to the command line.

function varargout = scoresDistribution_OutputFcn(hObject, eventdata, handles)

% varargout  cell array for returning output args (see VARARGOUT);

% hObject    handle to figure

% eventdata  reserved - to be defined in a future version of MATLAB

% handles    structure with handles and user data (see GUIDATA)



% Get default command line output from handles structure

varargout{1} = handles.output;
varargout{2}=handles.jaccards ;
varargout{3} =handles.cScores ;
varargout{4} =handles.jaccardsSTD ;
varargout{5} =    handles.fScoresSTD ;
% Hint: delete(hObject) closes the figure

delete(hObject);

% --------------------------------------------------------------------

function FileMenu_Callback(hObject, eventdata, handles)

% hObject    handle to FileMenu (see GCBO)

% eventdata  reserved - to be defined in a future version of MATLAB

% handles    structure with handles and user data (see GUIDATA)





% --------------------------------------------------------------------

function OpenMenuItem_Callback(hObject, eventdata, handles)

% hObject    handle to OpenMenuItem (see GCBO)

% eventdata  reserved - to be defined in a future version of MATLAB

% handles    structure with handles and user data (see GUIDATA)

file = uigetfile('*.fig');
if ~isequal(file, 0)
    open(file);
end



% --------------------------------------------------------------------

function PrintMenuItem_Callback(hObject, eventdata, handles)

% hObject    handle to PrintMenuItem (see GCBO)

% eventdata  reserved - to be defined in a future version of MATLAB

% handles    structure with handles and user data (see GUIDATA)

printdlg(handles.figure1)



% --------------------------------------------------------------------

function CloseMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to CloseMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

selection = questdlg(['Close ' get(handles.figure1,'Name') '?'],...
    ['Close ' get(handles.figure1,'Name') '...'],...
    'Yes','No','Yes');
if strcmp(selection,'No')
    return;
end
guidata(hObject, handles);
uiresume(handles.figure1);



% --- Executes on button press in plotTag.

function plotTag_Callback(hObject, eventdata, handles)
% hObject    handle to plotTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
%axes(handles.axes1);
%cla;
if get(handles.allTag,'Value')
    all=1;
else
    all=0;
end
if get(handles.bfsTag,'Value')
    bfs=1;
else
    bfs=0;
end
noLeaves  = get(handles.noLeavesTag,'Value');
[j,f,jstd,fstd,counts,enrichCount]=computeTreeScoreByLevels(handles.threshold,all,bfs,noLeaves);

handles.jaccards = j;
handles.fScores =f;
handles.cScores = enrichCount;
handles.jaccardsSTD = jstd;
handles.fScoresSTD =fstd;
len = length(handles.jaccards);

vec =0;
legends=[];
if  get(handles.jScoreTag,'Value')
       vec = handles.jaccards';
       legends = ['J-Score'];
end
if  get(handles.cScoreTag,'Value')
 legends=  [legends ;'C-Score'];
    if vec==0
        vec = handles.cScores';
      %  vec = vec(revOrder);
    else
        vec (:,2) = handles.cScores';  
    end
end
barh(vec);
ylabel('Branch Level (Root on top, Elements down)');
set(gca,'YDir','reverse');%num2str(revOrder'));
xlabel('Average Score');
xlim([0 1]);
%legend('J-Score','F-Score');
legend(legends);
if get(handles.elementsTag,'Value')
    for ind =1: len
        text (handles.cScores(ind),ind,num2str(counts(ind)));
    end
end
guidata(hObject, handles);
% --- Executes on button press in jScoreTag.

function jScoreTag_Callback(hObject, eventdata, handles)
% hObject    handle to jScoreTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of jScoreTag

% --- Executes when user attempts to close figure1.

function figure1_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

uiresume(handles.figure1);

% --------------------------------------------------------------------
function saveAsTag_Callback(hObject, eventdata, handles)
% hObject    handle to saveAsTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[file, dir, filterindex] = uiputfile( ...
    {'*.fig', 'MATLAB figure Files (*.fig)';'*.bmp','Bitmap files (*.bmp)'; '*.eps','EPS Level 1 (*.eps)'; '*.*',  'All Files (*.*)'}, ...
    'Save as');
full_file = fullfile(dir,file);
if (filterindex~=0)
    saveas(handles.axes1,full_file);
end





% --- Executes on button press in fScoreTag.
function cScoreTag_Callback(hObject, eventdata, handles)
% hObject    handle to fScoreTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Hint: get(hObject,'Value') returns toggle state of fScoreTag

% --- Executes on button press in checkbox4.

function checkbox4_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox4
% --- Executes on button press in elementsTag.
function elementsTag_Callback(hObject, eventdata, handles)
% hObject    handle to elementsTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Hint: get(hObject,'Value') returns toggle state of elementsTag


% --- Executes on button press in noLeavesTag.
function noLeavesTag_Callback(hObject, eventdata, handles)
% hObject    handle to noLeavesTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Hint: get(hObject,'Value') returns toggle state of noLeavesTag
