% function [partitionMatrix]= tree2partition(familyTree);
%    represent the family tree (a cell structure of children/ parent
%    relations) as a partition matrix (where all branch dictates a
%    partition.. for  each binary tree there exist n-2 non trivial
%    partitions.
%   
%      Example
%     Given the folowing tree:(1, 2 ,3 and 4  are the elements and a, b and c are branches
%      ===================================================
%                       c
%               /                  \
%              |                    | 
%              a                    b   
%            /    \                /  \  
%           |      |              |    |
%           1      2              4     3
%  -------------------------------------------------------------------------
%   The tree structure is:
%  {parent} {left child}    {right child}
%               -------------
%  {1 2 3 4}    {1 2}           {3 4}
%  {1 2}        {1}             {2}
%  {3 4}        {3}             {4}
%  -------------------------------------------------------------------------
% The  partition matrix is:
% 1   2   3   4
% -------------
% 1   1   0   0
% 0   0   1   1
% Where first row corresponds to branch a and the second to branch b
function [partitionMatrix]= tree2partition(familyTree)
partitionMatrix=create2ClassesFromFamilyTreeBranches(familyTree);% already implemented