function varargout = ultrametricDisp(varargin)
% ULTRAMETRICDISP M-file for ultrametricDisp.fig
%      ULTRAMETRICDISP, by itself, creates a new ULTRAMETRICDISP or raises the existing
%      singleton*.
%
%      H = ULTRAMETRICDISP returns the handle to a new ULTRAMETRICDISP or the handle to
%      the existing singleton*.
%
%      ULTRAMETRICDISP('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in ULTRAMETRICDISP.M with the given input arguments.
%
%      ULTRAMETRICDISP('Property','Value',...) creates a new ULTRAMETRICDISP or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before ultrametricDisp_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to ultrametricDisp_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help ultrametricDisp

% Last Modified by GUIDE v2.5 31-Dec-2006 16:25:34

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @ultrametricDisp_OpeningFcn, ...
                   'gui_OutputFcn',  @ultrametricDisp_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

% --- Executes just before ultrametricDisp is made visible.
function ultrametricDisp_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to ultrametricDisp (see VARARGIN)

% Choose default command line output for ultrametricDisp
handles.output = hObject;
handles.distMat=createUltrametricDistMatrix();
imagesc (handles.distMat);
% Update handles structure
guidata(hObject, handles);

% UIWAIT makes ultrametricDisp wait for user response (see UIRESUME)
uiwait(handles.figure1);

% --- Outputs from this function are returned to the command line.
function varargout = ultrametricDisp_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;
varargout{2}=handles.distMat;
delete(handles.figure1);

% --------------------------------------------------------------------
function FileMenu_Callback(hObject, eventdata, handles)
% hObject    handle to FileMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function OpenMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to OpenMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
file = uigetfile('*.fig');
if ~isequal(file, 0)
    open(file);
end

% --------------------------------------------------------------------
function PrintMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to PrintMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
printdlg(handles.figure1)

% --------------------------------------------------------------------
function CloseMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to CloseMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
selection = questdlg(['Close ' get(handles.figure1,'Name') '?'],...
                     ['Close ' get(handles.figure1,'Name') '...'],...
                     'Yes','No','Yes');
if strcmp(selection,'No')
    return;
end

%delete(handles.figure1)
guidata(hObject, handles);
uiresume(handles.figure1);


% --- Executes on button press in exportMenuTag.
function exportMenuTag_Callback(hObject, eventdata, handles)
% hObject    handle to exportMenuTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
button = questdlg('Export data as A..','Secify Target','Variable','File','Cancel','Variable');
    if strcmp(button,'Variable')
        prompt = {'Distances Matrix:'};
        dlg_title = 'Specify Variable';
        num_lines = 1;
        def = {'distMat'};
        answer = inputdlg(prompt,dlg_title,num_lines,def);
        if isempty(answer) == 0
            assignin('base',answer{1},handles.distMat);
        end
    elseif strcmp(button,'File')
          [filename, pathname, filterindex] = uiputfile( ...
            {'*.txt','Text file (*.txt)';...
            '*.*',  'All Files (*.*)'}, ...
            'Save as');
        if isempty(filename) ==0  
            csvwrite([pathname filename], handles.distMat);
        end
    end

% --- Executes on button press in closeTag.
function closeTag_Callback(hObject, eventdata, handles)
% hObject    handle to closeTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
CloseMenuItem_Callback(handles.CloseMenuItem, eventdata, handles);



% --- Executes on button press in exportTag.
function exportTag_Callback(hObject, eventdata, handles)
% hObject    handle to exportTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
exportMenuTag_Callback(handles.exportMenuTag, eventdata, handles);

function [distMat]=createUltrametricDistMatrix()
global hash;
[vals,inds]=sort(unique(hash(:,4)),'descend');%compute the levels
numElems = (hash(1,1)+1)/2;
distMat=zeros(numElems);
parents = hash(:,2);
indices = hash(:,1);
levels= hash(:,7);
parent = 1;
[distMat]=recursiveDist(parent,parents,vals,indices,levels,distMat);

function [distMat]=recursiveDist(parent,parents,vals,indices,levels,distMat)
%parentY=vals(parent);%root
parentLevel=max(levels) -levels(parent);
if parentLevel==0
    return;
% end
% 
%  if isempty(children)
%         return;
 else
     children = find(parents==parent);
     child1=children(1);
     child2=children(2);
     parentsElem=elementsBelow(parents,indices,indices(parent));
     childs1Elem=elementsBelow(parents,indices,indices(child1));
     childs2Elem=setdiff(parentsElem,childs1Elem);
     %childs2Elem=elementsBelow(parents,indices,indices(child2));     
     for ind=1:length(childs1Elem)%update distances of children
         distMat(childs1Elem(ind),childs2Elem)=parentLevel ;
         distMat(childs2Elem,childs1Elem(ind))=parentLevel ;%symmetric
     end
    distMat=recursiveDist(child1,parents,vals,indices,levels,distMat);
    distMat=recursiveDist(child2,parents,vals,indices,levels,distMat);
 end

